/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;

/**
 * This is a JSON template for an achievement reveal response
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AchievementRevealResponse extends GenericJson {

  /**
   * The current state of the achievement for which a reveal was attempted. This might be UNLOCKED
   * if the achievement was already unlocked. Possible values are:   - "REVEALED" - Achievement is
   * revealed.  - "UNLOCKED" - Achievement is unlocked.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String currentState;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#achievementRevealResponse.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The current state of the achievement for which a reveal was attempted. This might be UNLOCKED
   * if the achievement was already unlocked. Possible values are:   - "REVEALED" - Achievement is
   * revealed.  - "UNLOCKED" - Achievement is unlocked.
   * The value returned may be {@code null}.
   */
  public String getCurrentState() {
    return currentState;
  }

  /**
   * The current state of the achievement for which a reveal was attempted. This might be UNLOCKED
   * if the achievement was already unlocked. Possible values are:   - "REVEALED" - Achievement is
   * revealed.  - "UNLOCKED" - Achievement is unlocked.
   * The value set may be {@code null}.
   */
  public AchievementRevealResponse setCurrentState(String currentState) {
    this.currentState = currentState;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#achievementRevealResponse.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#achievementRevealResponse.
   * The value set may be {@code null}.
   */
  public AchievementRevealResponse setKind(String kind) {
    this.kind = kind;
    return this;
  }

}
