/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;

/**
 * This is a JSON template for the Leaderboard resource.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Leaderboard extends GenericJson {

  /**
   * The icon for the leaderboard.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String iconUrl;

  /**
   * The leaderboard ID.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Indicates whether the icon image being returned is a default image, or is game-provided.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean isIconUrlDefault;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#leaderboard.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The name of the leaderboard.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String name;

  /**
   * How scores are ordered. Possible values are:   - "LARGER_IS_BETTER" - Larger values are better;
   * scores are sorted in descending order.  - "SMALLER_IS_BETTER" - Smaller values are better;
   * scores are sorted in ascending order.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String order;

  /**
   * The icon for the leaderboard.
   * The value returned may be {@code null}.
   */
  public String getIconUrl() {
    return iconUrl;
  }

  /**
   * The icon for the leaderboard.
   * The value set may be {@code null}.
   */
  public Leaderboard setIconUrl(String iconUrl) {
    this.iconUrl = iconUrl;
    return this;
  }

  /**
   * The leaderboard ID.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * The leaderboard ID.
   * The value set may be {@code null}.
   */
  public Leaderboard setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Indicates whether the icon image being returned is a default image, or is game-provided.
   * The value returned may be {@code null}.
   */
  public Boolean getIsIconUrlDefault() {
    return isIconUrlDefault;
  }

  /**
   * Indicates whether the icon image being returned is a default image, or is game-provided.
   * The value set may be {@code null}.
   */
  public Leaderboard setIsIconUrlDefault(Boolean isIconUrlDefault) {
    this.isIconUrlDefault = isIconUrlDefault;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#leaderboard.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#leaderboard.
   * The value set may be {@code null}.
   */
  public Leaderboard setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The name of the leaderboard.
   * The value returned may be {@code null}.
   */
  public String getName() {
    return name;
  }

  /**
   * The name of the leaderboard.
   * The value set may be {@code null}.
   */
  public Leaderboard setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * How scores are ordered. Possible values are:   - "LARGER_IS_BETTER" - Larger values are better;
   * scores are sorted in descending order.  - "SMALLER_IS_BETTER" - Smaller values are better;
   * scores are sorted in ascending order.
   * The value returned may be {@code null}.
   */
  public String getOrder() {
    return order;
  }

  /**
   * How scores are ordered. Possible values are:   - "LARGER_IS_BETTER" - Larger values are better;
   * scores are sorted in descending order.  - "SMALLER_IS_BETTER" - Smaller values are better;
   * scores are sorted in ascending order.
   * The value set may be {@code null}.
   */
  public Leaderboard setOrder(String order) {
    this.order = order;
    return this;
  }

}
