/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * This is a JSON template for a score rank in a leaderboard.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class LeaderboardScoreRank extends GenericJson {

  /**
   * The number of scores in the leaderboard as a string.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String formattedNumScores;

  /**
   * The rank in the leaderboard as a string.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String formattedRank;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#leaderboardScoreRank.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The number of scores in the leaderboard.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long numScores;

  /**
   * The rank in the leaderboard.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long rank;

  /**
   * The number of scores in the leaderboard as a string.
   * The value returned may be {@code null}.
   */
  public String getFormattedNumScores() {
    return formattedNumScores;
  }

  /**
   * The number of scores in the leaderboard as a string.
   * The value set may be {@code null}.
   */
  public LeaderboardScoreRank setFormattedNumScores(String formattedNumScores) {
    this.formattedNumScores = formattedNumScores;
    return this;
  }

  /**
   * The rank in the leaderboard as a string.
   * The value returned may be {@code null}.
   */
  public String getFormattedRank() {
    return formattedRank;
  }

  /**
   * The rank in the leaderboard as a string.
   * The value set may be {@code null}.
   */
  public LeaderboardScoreRank setFormattedRank(String formattedRank) {
    this.formattedRank = formattedRank;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#leaderboardScoreRank.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#leaderboardScoreRank.
   * The value set may be {@code null}.
   */
  public LeaderboardScoreRank setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The number of scores in the leaderboard.
   * The value returned may be {@code null}.
   */
  public Long getNumScores() {
    return numScores;
  }

  /**
   * The number of scores in the leaderboard.
   * The value set may be {@code null}.
   */
  public LeaderboardScoreRank setNumScores(Long numScores) {
    this.numScores = numScores;
    return this;
  }

  /**
   * The rank in the leaderboard.
   * The value returned may be {@code null}.
   */
  public Long getRank() {
    return rank;
  }

  /**
   * The rank in the leaderboard.
   * The value set may be {@code null}.
   */
  public LeaderboardScoreRank setRank(Long rank) {
    this.rank = rank;
    return this;
  }

}
