/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * This is a JSON template for a room auto-match criteria object.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RoomAutoMatchingCriteria extends GenericJson {

  /**
   * A bitmask indicating when auto-matches are valid. When ANDed with other exclusive bitmasks, the
   * result must be zero. Can be used to support exclusive roles within a game.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long exclusiveBitmask;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#roomAutoMatchingCriteria.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The maximum number of players that should be added to the room by auto-matching.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer maxAutoMatchingPlayers;

  /**
   * The minimum number of players that should be added to the room by auto-matching.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer minAutoMatchingPlayers;

  /**
   * A bitmask indicating when auto-matches are valid. When ANDed with other exclusive bitmasks, the
   * result must be zero. Can be used to support exclusive roles within a game.
   * The value returned may be {@code null}.
   */
  public Long getExclusiveBitmask() {
    return exclusiveBitmask;
  }

  /**
   * A bitmask indicating when auto-matches are valid. When ANDed with other exclusive bitmasks, the
   * result must be zero. Can be used to support exclusive roles within a game.
   * The value set may be {@code null}.
   */
  public RoomAutoMatchingCriteria setExclusiveBitmask(Long exclusiveBitmask) {
    this.exclusiveBitmask = exclusiveBitmask;
    return this;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#roomAutoMatchingCriteria.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#roomAutoMatchingCriteria.
   * The value set may be {@code null}.
   */
  public RoomAutoMatchingCriteria setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The maximum number of players that should be added to the room by auto-matching.
   * The value returned may be {@code null}.
   */
  public Integer getMaxAutoMatchingPlayers() {
    return maxAutoMatchingPlayers;
  }

  /**
   * The maximum number of players that should be added to the room by auto-matching.
   * The value set may be {@code null}.
   */
  public RoomAutoMatchingCriteria setMaxAutoMatchingPlayers(Integer maxAutoMatchingPlayers) {
    this.maxAutoMatchingPlayers = maxAutoMatchingPlayers;
    return this;
  }

  /**
   * The minimum number of players that should be added to the room by auto-matching.
   * The value returned may be {@code null}.
   */
  public Integer getMinAutoMatchingPlayers() {
    return minAutoMatchingPlayers;
  }

  /**
   * The minimum number of players that should be added to the room by auto-matching.
   * The value set may be {@code null}.
   */
  public RoomAutoMatchingCriteria setMinAutoMatchingPlayers(Integer minAutoMatchingPlayers) {
    this.minAutoMatchingPlayers = minAutoMatchingPlayers;
    return this;
  }

}
