/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.games.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * This is a JSON template for a request to submit a score to leaderboards.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Play Game Services API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ScoreSubmission extends GenericJson {

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#scoreSubmission.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * The leaderboard this score is being submitted to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String leaderboardId;

  /**
   * The new score being submitted.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long score;

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#scoreSubmission.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Uniquely identifies the type of this resource. Value is always the fixed string
   * games#scoreSubmission.
   * The value set may be {@code null}.
   */
  public ScoreSubmission setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The leaderboard this score is being submitted to.
   * The value returned may be {@code null}.
   */
  public String getLeaderboardId() {
    return leaderboardId;
  }

  /**
   * The leaderboard this score is being submitted to.
   * The value set may be {@code null}.
   */
  public ScoreSubmission setLeaderboardId(String leaderboardId) {
    this.leaderboardId = leaderboardId;
    return this;
  }

  /**
   * The new score being submitted.
   * The value returned may be {@code null}.
   */
  public Long getScore() {
    return score;
  }

  /**
   * The new score being submitted.
   * The value set may be {@code null}.
   */
  public ScoreSubmission setScore(Long score) {
    this.score = score;
    return this;
  }

}
